
(defdomain simple-house (
 
;Operators
 (:operator (!place-block ?block-type ?x ?y ?z)
 		((clear ?x ?y ?z) (last-placed ?x2 ?y2 ?z2))
 		((clear ?x ?y ?z) (last-placed ?x2 ?y2 ?z2))
 		((block-at ?block-type ?x ?y ?z) (last-placed ?x ?y ?z))
 )

 (:operator (!remove-block ?block-type ?x ?y ?z)
		((block-at ?block-type ?x ?y ?z))
		((block-at ?block-type ?x ?y ?z))
		((clear ?x ?y ?z) (block-at-inventory ?block-type))
 )

; Methods
(:method (place-block ?block-type ?x ?y ?z)
    block-is-empty
        ((clear ?x ?y ?z))
        ((:task !place-block ?block-type ?x ?y ?z))

    block-is-same
        ((block-at ?block-type ?x ?y ?z))
        ()

	block-is-different
        ((block-at ?a ?x ?y ?z))
        (:ordered 
			(:task !remove-block ?a ?x ?y ?z)
			(:task !place-block ?block-type ?x ?y ?z)
		)
)

(:method (remove-block ?x ?y ?z)
	block-is-empty
	((clear ?x ?y ?z))
	()

	block-is-filled
	((block-at ?a ?x ?y ?z))
	((:task !remove-block ?a ?x ?y ?z))
	)




(:method (build-row ?x ?y ?z ?length ?dir)
		zero-length
		((call = ?length 0))
		()

		east
		((call = ?dir 1) (up ?x1 ?x) (up ?length ?l1))
		(:ordered
			(:task place-block "1:0" ?x ?y ?z)
			(:task build-row ?x1 ?y ?z ?l1 ?dir)
		)

		west
		((call = ?dir 2) (up ?x ?x1) (up ?length ?l1))
		(:ordered
			(:task place-block "1:0" ?x ?y ?z)
			(:task build-row ?x1 ?y ?z ?l1 ?dir)
		)

		north
		((call = ?dir 3) (up ?y1 ?y) (up ?length ?l1))
		(:ordered
			(:task place-block "1:0" ?x ?y ?z)
			(:task build-row ?x ?y1 ?z ?l1 ?dir)
		)

		south
		((call = ?dir 4) (up ?y ?y1) (up ?length ?l1))
		(:ordered
			(:task place-block "1:0" ?x ?y ?z)
			(:task build-row ?x ?y1 ?z ?l1 ?dir)
		)
)

(:method (build-wall-east ?x ?y ?z ?length ?height ?dir)
		zero-height
		((call = ?height 0))
		()

		east-one
		((up ?z1 ?z) (up ?height ?h1) (call = ?dir 1))
		(:ordered
			(:task build-row ?x ?y ?z ?length ?dir)
			(:task build-wall-east ?x ?y ?z1 ?length ?h1 ?dir)
		)
)

(:method (build-wall-east ?x ?y ?z ?length ?height ?dir)
		zero-height
		((call = ?height 0))
		()

		east-two
		((up ?z1 ?z) (up ?height ?h1) (call = ?dir 1))
		(:ordered
			(:task build-row (call - (call + ?x ?length) 1) ?y ?z ?length 2)
			(:task build-wall-east ?x ?y ?z1 ?length ?h1 ?dir)
		)
)


(:method (build-wall-west ?x ?y ?z ?length ?height ?dir)
		zero-height
		((call = ?height 0))
		()

		west-one
		((up ?z1 ?z) (up ?height ?h1) (call = ?dir 2))
		(:ordered
			(:task build-row ?x ?y ?z ?length ?dir)
			(:task build-wall-west ?x ?y ?z1 ?length ?h1 ?dir)
		)
)

(:method (build-wall-west ?x ?y ?z ?length ?height ?dir)
		zero-height
		((call = ?height 0))
		()

		west-two
		((up ?z1 ?z) (up ?height ?h1) (call = ?dir 2))
		(:ordered
			(:task build-row (call + (call - ?x ?length) 1) ?y ?z ?length 1)
			(:task build-wall-west ?x ?y ?z1 ?length ?h1 ?dir)
		)
)


(:method (build-wall-north ?x ?y ?z ?length ?height ?dir)
		zero-height
		((call = ?height 0))
		()

		north-one
		((up ?z1 ?z) (up ?height ?h1) (call = ?dir 3))
		(:ordered
			(:task build-row ?x ?y ?z ?length ?dir)
			(:task build-wall-north ?x ?y ?z1 ?length ?h1 ?dir)
		)
)

(:method (build-wall-north ?x ?y ?z ?length ?height ?dir)
		zero-height
		((call = ?height 0))
		()

		north-two
		((up ?z1 ?z) (up ?height ?h1) (call = ?dir 3))
		(:ordered
			(:task build-row ?x (call - (call + ?y ?length) 1) ?z ?length 4)
			(:task build-wall-north ?x ?y ?z1 ?length ?h1 ?dir)
		)
)

(:method (build-wall-south ?x ?y ?z ?length ?height ?dir)
		zero-height
		((call = ?height 0))
		()

		south-one
		((up ?z1 ?z) (up ?height ?h1) (call = ?dir 4))
		(:ordered
			(:task build-row ?x ?y ?z ?length ?dir)
			(:task build-wall-south ?x ?y ?z1 ?length ?h1 ?dir)
		)

)

(:method (build-wall-south ?x ?y ?z ?length ?height ?dir)
		zero-height
		((call = ?height 0))
		()

		south-two
		((up ?z1 ?z) (up ?height ?h1) (call = ?dir 4))
		(:ordered
			(:task build-row ?x (call + (call - ?y ?length) 1) ?z ?length 3)
			(:task build-wall-south ?x (call + (call - ?y ?length) 1) ?z1 ?length ?h1 ?dir)
		)

)

(:method (build-wall ?x ?y ?z ?length ?height ?dir)
		zero-height
		((call = ?height 0))
		()

		east
		((call = ?dir 1))
		(:ordered
			(:task build-wall-east ?x ?y ?z ?length ?height ?dir)
		)

		west
		((call = ?dir 2))
		(:ordered
			(:task build-wall-west ?x ?y ?z ?length ?height ?dir)
		)

		north
		((call = ?dir 3))
		(:ordered
			(:task build-wall-north ?x ?y ?z ?length ?height ?dir)
		)

		south
		((call = ?dir 4))
		(:ordered
			(:task build-wall-south ?x ?y ?z ?length ?height ?dir)
		)
)





(:method (build-roof-east ?x ?y ?z ?length ?width ?dir)
		zero-width
		((call = ?width 0))
		()

		east-one
		((up ?y1 ?y) (up ?length ?l1) (call = ?dir 1))
		(:ordered
			(:task build-row ?x ?y ?z ?length ?dir)
			(:task build-roof-east ?x ?y1 ?z ?l1 ?width ?dir)
		)
)

(:method (build-roof-east ?x ?y ?z ?length ?width ?dir)
		zero-width
		((call = ?width 0))
		()

		east-two
		((up ?y1 ?y) (up ?length ?l1) (call = ?dir 1))
		(:ordered
			(:task build-row (call - (call + ?x ?length) 1) ?y ?z ?length 2)
			(:task build-roof-east ?x  ?y1 ?z ?l1 ?width ?dir)
		)
)


(:method (build-roof-west ?x ?y ?z ?length ?width ?dir)
		zero-width
		((call = ?width 0))
		()

		west-one
		((up ?y1 ?y) (up ?length ?l1) (call = ?dir 2))
		(:ordered
			(:task build-row ?x ?y ?z ?length ?dir)
			(:task build-roof-west ?x ?y1 ?z ?l1 ?width 1)
		)
)

(:method (build-roof-west ?x ?y ?z ?length ?width ?dir)
		zero-width
		((call = ?width 0))
		()

		west-two
		((up ?y1 ?y) (up ?length ?l1) (call = ?dir 2))
		(:ordered
			(:task build-row (call + (call - ?x ?length) 1) ?y ?z ?length 1)
			(:task build-roof-west ?x ?y1 ?z ?l1 ?width ?dir)
		)
)

(:method (build-roof-north ?x ?y ?z ?length ?width ?dir)
		zero-width
		((call = ?width 0))
		()

		north-one
		((up ?x1 ?x) (up ?width ?w1) (call = ?dir 3))
		(:ordered
			(:task build-row ?x ?y ?z ?length ?dir)
			(:task build-roof-south ?x1 ?y ?z ?length ?w1 ?dir)
		)
)

(:method (build-roof-north ?x ?y ?z ?length ?width ?dir)
		zero-width
		((call = ?width 0))
		()

		north-two
		((up ?x1 ?x) (up ?width ?w1) (call = ?dir 3))
		(:ordered
			(:task build-row ?x (call - (call + ?y ?length) 1) ?z ?length 4)
			(:task build-roof-north ?x1 ?y ?z ?length ?w1 ?dir)
		)
)

(:method (build-roof-south ?x ?y ?z ?length ?width ?dir)
		zero-width
		((call = ?width 0))
		()

		south-one
		((up ?x1 ?x) (up ?width ?w1) (call = ?dir 4))
		(:ordered
			(:task build-row ?x ?y ?z ?length ?dir)
			(:task build-roof-south ?x1 ?y ?z ?length ?w1 ?dir)
		)

)

(:method (build-roof-south ?x ?y ?z ?length ?width ?dir)
		zero-width
		((call = ?width 0))
		()

		south-two
		((up ?x1 ?x) (up ?width ?w1) (call = ?dir 4))
		(:ordered
			(:task build-row ?x (call + (call - ?y ?length) 1) ?z ?length 3)
			(:task build-roof-south ?x1 ?y ?z ?length ?w1 ?dir)
		)

)


(:method (build-roof ?x ?y ?z ?length ?width ?dir)
		zero-width
		((call = ?width 0))
		()

		east
		((call = ?dir 1))
		(:ordered
			(:task build-roof-east ?x ?y ?z ?length ?width ?dir)
		)

		west
		((call = ?dir 2))
		(:ordered
			(:task build-roof-west ?x ?y ?z ?length ?width ?dir)
		)

		north
		((call = ?dir 3))
		(:ordered
			(:task build-roof-north ?x ?y ?z ?length ?width ?dir)
		)

		south
		((call = ?dir 4))
		(:ordered
			(:task build-roof-south ?x ?y ?z ?length ?width ?dir)
		)
)


(:method (build-door ?x ?y ?z)
	()
	(:ordered 
		(:task remove-block ?x ?y ?z)
		(:task remove-block ?x ?y (call + ?z 1))
	)
)



(:method (build-house ?x ?y ?z ?width ?length ?height)
		((call - (call + ?x ?width ) 1) )
		(
			(:task build-wall ?x ?y ?z ?width ?height 1)
			(:task build-wall (call - (call + ?x ?width ) 1) ?y ?z ?length ?height 3)
			(:task build-wall (call - (call + ?x ?width) 1) (call - (call + ?y ?length) 1) ?z ?width ?height 2)
			(:task build-wall ?x (call - (call + ?y ?length) 1) ?z ?length ?height 4)
			(:task build-door ?x (call - (call + (call ceiling ?length 2) ?y) 1) ?z)
			(:task build-roof ?x (call - (call + ?y ?length) 1) (call + ?z ?height) ?length ?width 4)
		)
)		



;Axioms
(:- (clear ?x ?y ?z)
	((not (block-at ?type ?x ?y ?z)))
	)

)
)
